SystemOrganization addCategory: #'FuelMooseExtension-Container'!
SystemOrganization addCategory: #'FuelMooseExtension-Container-Tests'!
SystemOrganization addCategory: #'FuelMooseExtension-Finder'!
SystemOrganization addCategory: #'FuelMooseExtension-Tests'!

TestResource subclass: #FLMaterializedLANPackageTestResource
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Tests'!

!FLMaterializedLANPackageTestResource methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 02:10'!
model
	^ model! !

!FLMaterializedLANPackageTestResource methodsFor: 'setup' stamp: 'MartinDias 5/20/2011 02:26'!
serializeAndMaterializeSourceModel
	"For debug: FLMaterializedLANPackageTestResource reset"

	| aStream |
	aStream := self stream.
	self sourceModel exportToFLStream: aStream.

	model := MooseModel new 
		importFromFLStream: aStream reset;
		yourself.
		
	"model sourceLanguage: #Smalltalk."! !

!FLMaterializedLANPackageTestResource methodsFor: 'setup' stamp: 'MartinDias 5/20/2011 02:04'!
setUp 
	 
	self serializeAndMaterializeSourceModel! !

!FLMaterializedLANPackageTestResource methodsFor: 'accessing' stamp: 'MartinDias 5/20/2011 01:58'!
sourceModel

	| sourceModel |
	sourceModel := MooseModel new.
	MooseSqueakClassPackageImporterTask new
		importerClass: SmalltalkImporter;
		model: sourceModel;
		addFromPackageNamed: #'Moose-TestResources-LAN';
		run.
	^ sourceModel! !

!FLMaterializedLANPackageTestResource methodsFor: 'setup' stamp: 'MartinDias 3/9/2011 02:33'!
stream 

	^ (RWBinaryOrTextStream on: '') binary! !

FamixModelExtractionTest subclass: #FLModelExtractionSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Tests'!

!FLModelExtractionSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/23/2011 03:49'!
model
	^ FLMaterializedLANPackageTestResource current model! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 4/29/2011 07:53'!
exportToFLOpeningFileDialog
	<menuItem: 'Export model to FL' category: 'Import / Export'>
	| stream |
	stream := UITheme builder 
		fileSave: 'Your title here'
		extensions: #('fl')
		path: nil.
	stream isNil ifFalse: [ 
		self exportToFLStream: stream.
		stream close.
		Notification signal: 'Save successful!!' ]! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 2/26/2011 05:46'!
exportToFLStream: aStream 
	FLMooseContainerWriter new on: aStream binary nextPut: self! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'TudorGirba 6/29/2011 22:36'!
importFromFLOpeningFileDialog
	| stream |	
	stream := UITheme builder
		fileOpen: 'Import model from Fuel file' 
		extensions: #('fl').
	stream isNil ifFalse: [
		self name: (FileDirectory baseNameFor: stream localName).
		self importFromFLStream: stream.
		stream close ]! !

!MooseModel methodsFor: '*FuelMooseExtension' stamp: 'MartinDias 9/13/2011 23:55'!
importFromFLStream: aStream
	
	| entities |
	entities := FLMooseContainerReader new nextOn: aStream binary.
	self entityStorage forSetup. 
	entities do: [ :e | self add: e ].
	self entityStorage forRuntime.
! !

FamixInvocationsTest subclass: #FLInvocationsSerializationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Tests'!

!FLInvocationsSerializationTest methodsFor: 'running' stamp: 'MartinDias 2/23/2011 03:49'!
model
	^ FLMaterializedLANPackageTestResource current model! !

TestCase subclass: #FLMooseContainerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Container-Tests'!

!FLMooseContainerTest methodsFor: 'accessing' stamp: 'MartinDias 2/26/2011 04:26'!
isWellKnownEntity: anObject
	^ ((anObject class = FAMIXAccess and: 
		[ anObject variable name = #self ]) and: 
		[ anObject accessor name = #hash ]) and:
		[ anObject accessor parentType name = #FLPair ]! !

!FLMooseContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 04:04'!
model
	^ MooseSqueakClassPackageImporterTask new
		model: MooseModel new;
		addClass: FLPair;
		run;
		model
! !

!FLMooseContainerTest methodsFor: 'accessing' stamp: 'MartinDias 2/26/2011 04:51'!
mooseModelAssert: writen equals: read
	self assert: MooseModel equals: writen class.
	self assert: MooseModel equals: read class.
	self assert: writen size equals: read size.
	self assert: 2 equals: (writen count: [ :anEntity | self isWellKnownEntity: anEntity ]). 
	self assert: 2 equals: (read count: [ :anEntity | self isWellKnownEntity: anEntity ]).
! !

!FLMooseContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 03:59'!
reader
	^ FLMooseContainerReader new! !

!FLMooseContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 04:00'!
stream
	^ (RWBinaryOrTextStream on: '') binary! !

!FLMooseContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 05:25'!
testBadStream

	| aStream |
	aStream := #[0 0 0 0 0 0 0 0] readStream binary.
	self should: [ self reader nextOn: aStream ] raise: Error! !

!FLMooseContainerTest methodsFor: 'tests' stamp: 'MartinDias 2/26/2011 05:25'!
testSuccess

	| aStream read written |
	aStream := self stream.
	written := self model.
	self writer on: aStream nextPut: written.
	read := self reader nextOn: aStream reset.
	self mooseModelAssert: written equals: read.! !

!FLMooseContainerTest methodsFor: 'running' stamp: 'MartinDias 2/26/2011 03:59'!
writer
	^ FLMooseContainerWriter new! !

MPImportCommand subclass: #FLMooseImportCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Finder'!

!FLMooseImportCommand commentStamp: 'MartinDias 2/23/2011 00:57' prior: 0!
I am a command for importing using Fuel extension, and I am shown on the MoosePanel.!

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 2/24/2011 12:33'!
execute
	| model |
	model := MooseModel new.
	model importFromFLOpeningFileDialog.
	model size > 0 ifTrue: [
		model install.
		self addModel: model ]! !

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'MartinDias 2/15/2011 14:30'!
icon
	^ MooseIcons mooseImportFuel! !

!FLMooseImportCommand methodsFor: 'hooks' stamp: 'TudorGirba 4/30/2011 14:02'!
label
	^ 'Import model from FL file'! !

Object subclass: #FLMooseContainerReader
	instanceVariableNames: 'containerReader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Container'!

!FLMooseContainerReader methodsFor: 'initialize-release' stamp: 'MartinDias 8/24/2011 23:13'!
initialize
	super initialize.
	containerReader := FLContainerReader new.
	containerReader materializers at: 15 put: [ :aStream | self materializer15on: aStream ].
	containerReader signature: 'FLMoose' asByteArray! !

!FLMooseContainerReader methodsFor: 'initialize-release' stamp: 'MartinDias 9/14/2011 00:09'!
materializer15on: aStream
	"Materializer for release version 1.5."

	| entities model |
	entities := (FLMaterializer newDefault 
		showProgress; 
		materializeFrom: aStream)
		root.
	
	model := MooseModel new.
	entities do: [ :e | model add: e ].
	model entityStorage forRuntime.
	^ model! !

!FLMooseContainerReader methodsFor: 'reading' stamp: 'MartinDias 2/26/2011 05:25'!
nextOn: aStream
	^ containerReader nextOn: aStream! !

Object subclass: #FLMooseContainerWriter
	instanceVariableNames: 'containerWriter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FuelMooseExtension-Container'!

!FLMooseContainerWriter methodsFor: 'initialize-release' stamp: 'MartinDias 8/24/2011 23:16'!
initialize
	super initialize.
	containerWriter := FLContainerWriter new.
	containerWriter serializers at: 15 put: [ :aStream :aModel | self serializer15on: aStream model: aModel ].
	containerWriter
		signature: 'FLMoose' asByteArray;
		currentVersion: 15! !

!FLMooseContainerWriter methodsFor: 'writing' stamp: 'MartinDias 2/26/2011 05:27'!
on: aStream nextPut: aMooseModel
	containerWriter on: aStream nextPut: aMooseModel! !

!FLMooseContainerWriter methodsFor: 'initialize-release' stamp: 'MartinDias 9/14/2011 00:51'!
serializer15on: aStream model: aModel
	"Serializer for release version 1.5."
	
	FLSerializer newDefault
		analyzer: FLFameAnalyzer newDefault;
		showProgress;
		serialize: aModel entities 
		on: aStream! !
